#ifndef _ANIMATE_H
#define _ANIMATE_H

#include "sprite.h"
#include "wait.h"

#ifndef MAXX
#define MAXX  319
#define MAXY  199
#endif

#ifndef BYTE
typedef unsigned char	BYTE;
typedef unsigned int	WORD;
#endif

#define DEFAULT_WAIT_TIME	WAIT_10th

class Animator
{
	private:
		Sprite *sprite;               // pointer to sprite to animate
		int dx, dy;                   // offsets to move sprite by
		float wait_time;			  // us wait_time to sleep between steps
		int **sequences;              // sequences of sprites to animate
		int num_sequences;            // number of sequences
		int *sequence_lens;           // sequence lengths
		int *sequence_key_codes;      // keycode to trigger sequences
		BYTE *screen;
	public:
		Animator(Sprite *InitSprite, int **InitSequences,
			int InitNumSequences, int *InitSequenceLens,
			int *InitSequenceKeyCodes, BYTE *InitScreen);
		void QuickAnimate();
		void FullAnimate();
		void SetNewSprite(Sprite *NewSprite)
		{ sprite = NewSprite; };
		void SetNewSequences(int **NewSequences, int NewNumSequences,
			int *NewSequenceLens, int *NewSequenceKeyCodes);
}; /* class Animator */

#endif

