/*************************************************************************

	FILE:		BOX.H

	AUTHOR:		Brian Tegart, C.E.T.

	DATE:		April 30, 1995

	DESCRIPTION:	Include file for Graphics rectangle

	COPYRIGHT (c) 1995 Tegart Software

==========================================================================

	Revision:	0.0

	Date:		April 30, 1995

	By:		Brian Tegart, C.E.T.

	Action:		Creation and modification from old file

**************************************************************************/

#ifndef _BOX_H
#define _BOX_H

/************/
/* Includes */
/************/
#include "rectangl.h"

/***********/
/* Defines */
/***********/
#define DEFAULT_LINES	2

#define NOSAVE_BG	0
#define SAVE_BG		1

#define AUTO_CALC	-1	// have classes auto calc X2 and Y2 for fit

/***************************/
/* Typedefs and structures */
/***************************/

/*********************/
/* Public prototypes */
/*********************/

// Declaration of Box class
class Box : public Rectangle
{
	protected:
		int TopColor;	// color for top edge
		int BottomColor;// color for bottom edge
		int NumEdgeLines;
		int SaveBG;	// whether background is to be saved
		int SavedBG;	//    "		"     is currently saved
		BYTE *screen;
		BYTE *background;
		void SaveBackground();
		void RestoreBackground();
		void DrawEdges();
		void SwapEdgeColors();
	public:
		Box(int InitX1, int InitY1, int InitX2, int InitY2,
			int InitColor, int InitTopColor,
			int InitBottomColor, int InitSaveBGState,
			BYTE *InitScreen,
			int InitNumEdgeLines = DEFAULT_LINES);
		void Show();
		void Hide();
		void ReShow();
		void MoveTo(int NewX1, int NewY1, int NewX2, int NewY2);
		void ChangeEdgeColors(int NewTopColor, int NewBottomColor)
		{ TopColor = NewTopColor; BottomColor = NewBottomColor; };
		void GetEdgeColors(int *GetTopColor, int *GetBottomColor)
		{ *GetTopColor = TopColor; *GetBottomColor = BottomColor; };
		~Box();
}; // Box class declaration

#endif
