/*************************************************************************

	FILE:		BUTTON.H

	AUTHOR:		Brian Tegart, C.E.T.

	DATE:		May 1, 1995

	DESCRIPTION:	Include file for Button classes

	COPYRIGHT (c) 1995 Tegart Software

==========================================================================

	Revision:	0.0

	Date:		May 1, 1995

	By:		Brian Tegart, C.E.T.

	Action:		Creation and modification from old file

**************************************************************************/

#ifndef _BUTTON_H
#define _BUTTON_H

/************/
/* Includes */
/************/
#include "control.h"
#include "font.h"

/***********/
/* Defines */
/***********/
#define CENTER_TEXT	0	// Vertical or horizontal
#define LEFT_TEXT	1	// Horizontal
#define RIGHT_TEXT	2	// Horizontal
#define TOP_TEXT        1	// Vertical
#define BOTTOM_TEXT	2	// Vertical

/***************************/
/* Typedefs and structures */
/***************************/

/*********************/
/* Public prototypes */
/*********************/

// Declaration of Button class
class Button : public Control
{
	protected:
	public:
		Button(int InitX1, int InitY1, int InitX2, int InitY2,
			int InitColor, int InitTopColor,
			int InitBottomColor, int InitValue,
			BYTE *InitScreen,
			int InitNumEdgeLines = DEFAULT_LINES);
		void Push();
		void Release();
}; // Button class declaration

// Declaration of TextButton Class
class TextButton : public Button
{
	protected:
		char *Text;
		FontStruct *FontPtr;
		int TextColor;
		int X_Just;
		int Y_Just;
	public:
		TextButton(int InitX1, int InitY1, int InitX2, int InitY2,
			int InitColor, int InitTopColor, int InitBottomColor,
			int InitValue, char *InitText, int InitTextColor,
			FontStruct *InitFontPtr, BYTE *InitScreen,
			int InitXJust = CENTER_TEXT,
			int InitYJust = TOP_TEXT,
			int InitNumEdgeLines = DEFAULT_LINES);
		void Show();
		void Hide();
		char *GetText()
		{ return Text; };
}; // TextButton class declaration

#endif
