/*************************************************************************

	FILE:       	CONTROL.CPP

	AUTHOR:     	Brian Tegart, C.E.T.

	DATE:       	May 2, 1995

	DESCRIPTION:    Code for Control class

	COPYRIGHT (c) 1995 Tegart Software

==========================================================================

	Revision:	0.0

	Date:		May 2, 1995

	By:		Brian Tegart, C.E.T.

	Action:		Creation

**************************************************************************/

/************/
/* Includes */
/************/
#include "control.h"

/***********/
/* Defines */
/***********/

/********************/
/* Global variables */
/********************/

/**********************/
/* External variables */
/**********************/

/******************************/
/* Static function prototypes */
/******************************/

/********************/
/* Static functions */
/********************/

/********************/
/* Public functions */
/********************/

/*------------------------------------------------------------------------

Prototype:	Control::Control(int InitX1, int InitY1, int InitX2,
			int InitY2, int InitColor, int InitTopColor,
			int InitBottomColor, int InitValue,
			BYTE *InitScreen, int InitNumEdgeLines);

Description:	Control Constructor

Input:		InitX1		- X1 Coordinate
		InitY1		- Y1 Coordinate
		InitX2		- X2 Coordinate
		InitY2		- Y2 Coordinate
		InitColor	- Face color
		InitTopColor	- Top edge color
		InitBottomColor	- Bottom edge color
		InitValue	- Value associated with button
		InitScreen	- Screen buffer for button
		InitNumEdgeLines- Thickness of edge

Modified:	none

Output:		none

Returns:	none

Side effects:	none

-------------------------------------------------------------------------*/
Control::Control(int InitX1, int InitY1, int InitX2, int InitY2,
		int InitColor, int InitTopColor, int InitBottomColor,
		int InitValue, BYTE *InitScreen, int InitNumEdgeLines)
	: Box(InitX1, InitY1, InitX2, InitY2, InitColor, InitTopColor,
		InitBottomColor, NOSAVE_BG, InitScreen, InitNumEdgeLines)
{
	Value = InitValue;
	Deactivate();
} // Control Constructor

