/*************************************************************************

	FILE:		CONTROL.H

	AUTHOR:		Brian Tegart, C.E.T.

	DATE:		May 2, 1995

	DESCRIPTION:	Include file for Control class

	COPYRIGHT (c) 1995 Tegart Software

==========================================================================

	Revision:	0.0

	Date:		May 2, 1995

	By:		Brian Tegart, C.E.T.

	Action:		Creation

**************************************************************************/

#ifndef _CONTROL_H
#define _CONTROL_H

/************/
/* Includes */
/************/
#include "box.h"

/***********/
/* Defines */
/***********/
#define CENTER_TEXT	0	// Vertical or horizontal
#define LEFT_TEXT	1	// Horizontal
#define RIGHT_TEXT	2	// Horizontal
#define TOP_TEXT        1	// Vertical
#define BOTTOM_TEXT	2	// Vertical

/***************************/
/* Typedefs and structures */
/***************************/

/*********************/
/* Public prototypes */
/*********************/

// Declaration of Control class
class Control : public Box
{
	protected:
		int Value;
		int Active;
		void SwapEdgeColors();
		void Activate()		{ Active = TRUE; };
		void Deactivate()	{ Active = FALSE; };
	public:
		Control(int InitX1, int InitY1, int InitX2, int InitY2,
			int InitColor, int InitTopColor,
			int InitBottomColor, int InitValue,
			BYTE *InitScreen,
			int InitNumEdgeLines);
		int GetValue()		{ return Value; };
}; // Control class declaration

#endif
