#include <conio.h>
#include <dos.h>
#include <stdio.h>
#include "editclr.h"
#include "evntmngr.h"
#include "font.h"
#include "keyboard.h"
#include "mouse.h"
#include "popup.h"
#include "scancode.h"
#include "screen.h"

extern int event_mask;
extern BYTE *screen;
extern Mouse mouse;

ColorEditor::ColorEditor(int InitX1, int InitY1, int InitX2, int InitY2,
		int InitColor, int InitTopColor, int InitBottomColor,
		BYTE *InitScreen, FontStruct *InitFontPtr,
		char *InitText, int InitTextColor,
		int InitYOffset, BYTE *InitPalette, int InitColorNum,
		int InitLines) :
	PopUp(InitX1, InitY1, InitX2, InitY2, InitColor, InitTopColor,
		InitBottomColor, InitScreen, InitFontPtr, InitText, InitTextColor,
		BUT_OKCANCEL, InitYOffset, InitLines)
{
	int i;
	char RGBNames[3][6] = { "Red", "Green", "Blue" };
	char ValNames[4][4] = { "-10", "-1", "+1", "+10" };

	palette = InitPalette;
	colornum = InitColorNum;
	for(i=0;i<3;i++)
	{
		RGBButs[i] = new TextButton(X1+25, Y1+25+(i*20), X1+75,Y1+41+(i*20),
			InitColor, InitTopColor, InitBottomColor, NOSAVE_BG, InitScreen,
			RGBNames[i], InitFontPtr, InitTextColor, CENTER_TEXT,
			CENTER_TEXT, Lines);
		RGBVals[i] = (int)(palette[colornum*3+i] & 0x3f);
		RGBOrig[i] = RGBVals[i];
	}
	for(i=0;i<4;i++)
	{
		ValButs[i] = new TextButton(X1+25+(i*55),Y1+85,X1+75+(i*55),Y1+101,
			InitColor, InitTopColor, InitBottomColor, NOSAVE_BG, InitScreen,
			ValNames[i], InitFontPtr, InitTextColor, CENTER_TEXT,
			CENTER_TEXT, Lines);
	}
	Reset = new TextButton(X1+110, Y1+110, X1+160, Y1+126, InitColor,
		InitTopColor, InitBottomColor, NOSAVE_BG, InitScreen, "Reset",
		InitFontPtr, InitTextColor, CENTER_TEXT, CENTER_TEXT, Lines);
	redgreenorblue = RGB_RED;
} // ColorEditor::ColorEditor

void ColorEditor::Show()
{
	int i;

	if(Visible)
		return;
	PopUp::Show();
	for(i=0;i<3;i++)
		RGBButs[i]->Show();
	Reset->Show();
	for(i=0;i<4;i++)
		ValButs[i]->Show();
	boxdraw(X1+175, Y1+25, X1+245, Y1+81, colornum, screen);
	ShowVals();
	RGBButs[RGB_RED]->Push();
} // ColorEditor::Show

void ColorEditor::Hide()
{
	int i;

	if(!Visible)
		return;
	for(i=0;i<3;i++)
		RGBButs[i]->ColorHide(Color);
	Reset->ColorHide(Color);
	for(i=0;i<4;i++)
		ValButs[i]->ColorHide(Color);
	PopUp::Hide();
} // ColorEditor::Hide

void ColorEditor::ShowVals()
{
	char buffer[5];
	int i;

	for(i=0;i<3;i++)
	{
		sprintf(buffer, "%d", RGBVals[i]);
		GraphString(FontPtr, X1+110, Y1+30+(i*20), TextColor,
			buffer, screen);
	}
} // ColorEditor::ShowVals

void ColorEditor::HideVals()
{
	char buffer[5];
	int i;

	for(i=0;i<3;i++)
	{
		sprintf(buffer, "%d", RGBVals[i]);
		GraphString(FontPtr, X1+110, Y1+30+(i*20), Color,
			buffer, screen);
	}
} // ColorEditor::HideVals

void ColorEditor::ResetColor()
{
	int i;

	HideVals();
	for(i=0;i<3;i++)
		RGBVals[i] = RGBOrig[i];
	ShowVals();
	setcolor(colornum, (BYTE)RGBVals[RGB_RED], (BYTE)RGBVals[RGB_GREEN],
		(BYTE)RGBVals[RGB_BLUE]);
} // ColorEditor::Reset

void ColorEditor::ModifyValue(int ValButton)
{
	switch(ValButton)
	{
		case 0:
			RGBVals[redgreenorblue] -= 10;
			if(RGBVals[redgreenorblue] < 0)
				RGBVals[redgreenorblue] = 0;
			break;
		case 1:
			RGBVals[redgreenorblue] -= 1;
			if(RGBVals[redgreenorblue] < 0)
				RGBVals[redgreenorblue] = 0;
			break;
		case 2:
			RGBVals[redgreenorblue]++;
			if(RGBVals[redgreenorblue] > 63)
				RGBVals[redgreenorblue] = 63;
			break;
		case 3:
			RGBVals[redgreenorblue]+=10;
			if(RGBVals[redgreenorblue] > 63)
				RGBVals[redgreenorblue] = 63;
			break;
	}
} // ColorEditor::ModifyValue

int ColorEditor::HandleEvent(int Event_Type, int Event)
{
	int rc;
	int mx,my;
	int bX1, bY1, bX2, bY2;
	int i,j;
	int ValBut;

	rc = PopUp::HandleEvent(Event_Type, Event);
	if(rc == BUT_OK)
	{
		palette[colornum*3] = (BYTE)RGBVals[RGB_RED];
		palette[colornum*3+1] = (BYTE)RGBVals[RGB_GREEN];
		palette[colornum*3+2] = (BYTE)RGBVals[RGB_BLUE];
	}
	if(rc == BUT_CANCEL)
		ResetColor();
	if(rc)
		return rc;

	if((Event_Type & MOUSE_EVENT)&&
		((Event & LBUTTONDOWN)||(Event & LBUTTONHELD)||(Event & LBUTTONUP)))
	{
		mouse.GetPos(&mx, &my);
		for(i=0;i<3;i++)
		{
			RGBButs[i]->GetCoords(&bX1, &bY1, &bX2, &bY2);
			if((mx>=bX1)&&(mx<=bX2)&&(my>=bY1)&&(my<=bY2))    // if in this
			{												  //    button
				RGBButs[i]->Push();
				for(j=0;j<3;j++)	// Release the other buttons
				  if(i!=j)
					RGBButs[j]->Release();
				redgreenorblue = i;
			}
		}
		Reset->GetCoords(&bX1, &bY1, &bX2, &bY2);
		if((mx>=bX1)&&(mx<=bX2)&&(my>=bY1)&&(my<=bY2))    // if in the reset
		{                                                 //    button
			if((Event & LBUTTONDOWN) || (Event & LBUTTONHELD))
				Reset->Push();
			if(Event & LBUTTONUP)
			{
				Reset->Release();
				ResetColor();
			}
		}
		else
			Reset->Release();
		for(i=0;i<4;i++)
		{
			ValButs[i]->GetCoords(&bX1, &bY1, &bX2, &bY2);
			if((mx>=bX1)&&(mx<=bX2)&&(my>=bY1)&&(my<=bY2))
			{
				if((Event & LBUTTONDOWN) || (Event & LBUTTONHELD))
					ValButs[i]->Push();
				if(Event & LBUTTONUP)
				{
					ValButs[i]->Release();
					HideVals();
					ModifyValue(i);
					ShowVals();
					setcolor(colornum, (char)RGBVals[RGB_RED],
						(char)RGBVals[RGB_GREEN], (char)RGBVals[RGB_BLUE]);
				}
			}
			else
				ValButs[i]->Release();
		}
	}
	else if(Event_Type & KEYBOARD_EVENT)
	{
		if((Event==SCODEPGUP)||(Event==SCODEPGDN)
			||(Event==SCODEUP)||(Event==SCODEDOWN))
		{
			switch(Event)
			{
				case SCODEPGUP:   // Plus 10
					ValBut = 3;
					break;
				case SCODEUP:		// Plus 1
					ValBut = 2;
					break;
				case SCODEDOWN:
					ValBut = 1;
					break;
				case SCODEPGDN:
					ValBut = 0;
					break;
			}
			HideVals();
			ModifyValue(ValBut);
			setcolor(colornum, (BYTE)RGBVals[RGB_RED],
				(BYTE)RGBVals[RGB_GREEN], (BYTE)RGBVals[RGB_BLUE]);
			ShowVals();
		}
		else
		{
			switch(Event)
			{
				case SCODER: case SCODEr: // red
					for(i=0;i<3;i++)
						RGBButs[i]->Release();
					RGBButs[RGB_RED]->Push();
					redgreenorblue = RGB_RED;
					break;
				case SCODEG: case SCODEg: // green
					for(i=0;i<3;i++)
						RGBButs[i]->Release();
					RGBButs[RGB_GREEN]->Push();
					redgreenorblue = RGB_GREEN;
					break;
				case SCODEB: case SCODEb: // blue
					for(i=0;i<3;i++)
						RGBButs[i]->Release();
					RGBButs[RGB_BLUE]->Push();
					redgreenorblue = RGB_BLUE;
					break;
				case SCODEAR:     // reset
					ResetColor();
					break;
			}
		}
	} // end of if keyboard event
	return 0;                    // Nothing to do
} // ColorEditor::HandleEvent

ColorEditor::~ColorEditor()
{
	int i;
	for(i=0;i<3;i++)
		delete RGBButs[i];
	for(i=0;i<4;i++)
		delete ValButs[i];
	delete Reset;
} // ColorEditor::~ColorEditor
