#ifndef _EVNTMNGR_H
#define _EVNTMNGR_H

#include "anim256.h"

#ifndef BYTE
typedef unsigned char	BYTE;
typedef unsigned int	WORD;
#endif

// events
#define NOEVENT		0
#define LEFT		1
#define RIGHT		2
#define UP			4
#define	DOWN		8
#define	LBUTTONDOWN	16
#define RBUTTONDOWN	32
#define LBUTTONHELD	64
#define RBUTTONHELD	128
#define LBUTTONUP	256
#define RBUTTONUP	512

// event masks
#define MOUSE_EVENTS	1
#define JOYSTICK_EVENTS	2
#define	KEYBOARD_EVENTS	4

// event types
#define MOUSE_EVENT		1
#define JOYSTICK_EVENT	2
#define KEYBOARD_EVENT	4

int init_events();	// Initialize event manager
void setmin();		// Set minimum joystick callibrations
void setmax();		// Set maximum joystick callibrations
void setcenter();	// Set center joystick callibrations
void getevent(int event_mask, int *event_type, int *event);
int MouseWithin(SpriteGrid &MySpriteGrid);	 // See if mouse on spritegrid
int MouseWithin(PaletteGrid &MyPaletteGrid); // see if mouse on palettegrid
int MouseWithin(SpriteDisplayer &MySpriteDisp); // see if mouse on spritedisp
int MouseWithin(MenuSystem &MyMenu);    // see if mouse on menu
int HandleEvent(SpriteGrid &MySpriteGrid, PaletteGrid &MyPaletteGrid,
		SpriteDisplayer &MySpriteDisp, MenuSystem &MyMenu,
		int EventType, int Event);		// Pass event to correct object

#endif

