;*************************************************************************
;
;	FILE:		KEYBOARD.ASM
;
;	AUTHOR:		Brian Tegart, C.E.T.
;
;	DATE:		April 30, 1995
;
;	DESCRIPTION:	Keyboard routines
;
;	COPYRIGHT (c) 1995 Tegart Software
;
;=========================================================================
;
;	Revision:	0.0
;
;	Date:		April 30, 1995
;
;	By:		Brian Tegart, C.E.T.
;
;	Action:		Creation and modification from old file
;
;*************************************************************************

;**************
;* Directives *
;**************
.MODEL	large
.CODE

;************
;* Includes *
;************

;*************************
;* Function declarations *
;*************************
PUBLIC	_scankey

;***********
;* Equates *
;***********

;**************
;* Structures *
;**************

;***************
;* Global data *
;***************

;*****************
;* External data *
;*****************

;********************
;* Public functions *
;********************

;------------------------------------------------------------------------
;
;Prototype:	int scankey();
;
;Description:   Get scan code of last key pressed
;
;Input:		none
;
;Modified:	none
;
;Output:	none
;
;Returns:	none
;
;Side effects:	none
;
;------------------------------------------------------------------------
_scankey  PROC
	mov	ah,1			; Specify function 1 (key status)
	int	16h			; Call BIOS keyboard interrupt
	jz	nokey			; If no key pressed, skip ahead
	xor	ah,ah			; Else specific function 0 (get
					;	last key code)
	int	16h			; Call BIOS keyboard interrupt
	ret				; Return value
nokey:					; If no key pressed
	xor	ax,ax			; Return value of zero
	ret
_scankey  ENDP

	END
