#include <conio.h>
#include <dos.h>
#include <string.h>
#include <stdio.h>
#include "evntmngr.h"
#include "font.h"
#include "keyboard.h"
#include "menu.h"
#include "mouse.h"
#include "scancode.h"
#include "screen.h"

extern int event_mask;
extern Mouse mouse;

PullDown::PullDown(int InitX1, int InitY1,
		int InitColor, int InitTopColor, int InitBottomColor,
		char **InitTopics, BYTE *InitScreen, FontStruct *InitFontPtr,
		int InitTextColor, int InitLines) :
	TextButton(InitX1, InitY1, InitX1, InitY1,
			InitColor, InitTopColor, InitBottomColor,
			SAVE_BG, InitScreen, "", InitFontPtr, InitTextColor,
			CENTER_TEXT, CENTER_TEXT, InitLines)
{
	int maxlen=0, templen;
	int i=0;
	int down;
	int InitX2, InitY2;

	NumTopics = 0;
	while(InitTopics[i][0])
	{
		NumTopics++;
		templen = strlen(InitTopics[i]);
		if(templen > maxlen)
			maxlen = templen;
		i++;
	}
	InitX2 = InitX1+maxlen*FontPtr->width+InitLines+InitLines+3;
	InitY2 = InitY1+NumTopics*(FontPtr->height+2)+InitLines+InitLines+3;
	MoveTo(InitX1, InitY1, InitX2, InitY2);
	Topics = InitTopics;
	StringCoords = new int *[NumTopics];
	down = InitLines + 2;
	for(i=0;i<NumTopics;i++,down+=(FontPtr->height+2))
	{
		StringCoords[i] = new int [4];
		StringCoords[i][0] = InitX1 + InitLines;
		StringCoords[i][1] = InitY1 + down;
		StringCoords[i][2] = InitX2 - InitLines;
		StringCoords[i][3] = InitY1 + down + FontPtr->height+1;
	}
} // PullDown constructor

void PullDown::Show()
{
	int i=0;

	if(Visible)
		return;
	mouse.MaybeHide();
	Button::Show();
	for(i=0;i<NumTopics;i++)
		GraphString(FontPtr, StringCoords[i][0]+3, StringCoords[i][1] + 1,
			TextColor, Topics[i], screen);
	Selection = 0;
	HighLight(Selection);
	mouse.MaybeShow();
} // PullDown::Show

void PullDown::HighLight(int Topic)
{
	negatebox(StringCoords[Topic][0],StringCoords[Topic][1],
		StringCoords[Topic][2],StringCoords[Topic][3], screen);
	GraphString(FontPtr, StringCoords[Topic][0]+3, StringCoords[Topic][1]+1,
		TextColor, Topics[Topic], screen);
} // PullDown::HighLight

void PullDown::SetSelection(int NewSelection)
{
	if(NewSelection<0)
		NewSelection = NumTopics - 1;
	if(NewSelection>=NumTopics)
		NewSelection = 0;
	if(NewSelection != Selection)
	{
		mouse.MaybeHide();
		HighLight(Selection);
		Selection = NewSelection;
		HighLight(Selection);
		mouse.MaybeShow();
	}
} // PullDown::SetSelection

PullDown::~PullDown()
{
	int i;

	if(Visible)
		Hide();
	for(i=0;i<NumTopics;i++)
		delete StringCoords[i];
	delete StringCoords;
} // PullDown destructor

MenuSystem::MenuSystem(int InitX1, int InitY1, int InitX2, int InitY2,
		int InitColor, int InitTopColor, int InitBottomColor,
		char **InitHeaders, BYTE *InitScreen, FontStruct *InitFontPtr,
		int InitTextColor, int InitLines) :
	TextButton(InitX1, InitY1, InitX2, InitY2,
			InitColor, InitTopColor, InitBottomColor, NOSAVE_BG,
			InitScreen, "", InitFontPtr, InitTextColor, CENTER_TEXT,
			CENTER_TEXT, InitLines)
{
	int pX1 = InitX1, pY1;
	int counter=0;
	char **PullDownTopics;
	int offset = 0;

	pY1 = InitY2+1;
	Headers = InitHeaders;
	NumHeaders = 0;
	while(Headers[NumHeaders++][0]);
	NumHeaders--;
	PullDowns = new PullDown *[NumHeaders];
	PullDownTopics = &(Headers[NumHeaders+1]);
	StringCoords = new int *[NumHeaders];
	for(int i=0;i<NumHeaders;i++)
	{
		PullDowns[i] = new PullDown(pX1, pY1, InitColor, InitTopColor,
			InitBottomColor, PullDownTopics, InitScreen, InitFontPtr,
			InitTextColor, InitLines);
		while(PullDownTopics[counter++][0]);
		counter--;
		PullDownTopics = &(PullDownTopics[counter+1]);
		pX1 += ((strlen(Headers[i]) + 1) * FontPtr->width);
		counter = 0;
		StringCoords[i] = new int [4];
		StringCoords[i][0] = InitX1+InitLines+2+offset;
		StringCoords[i][1] = InitY1+InitLines+2;
		StringCoords[i][2]
			= InitX1+InitLines+2+offset+(strlen(Headers[i])
					* FontPtr->width);
		StringCoords[i][3] = InitY1+InitLines+FontPtr->height + 2;
		offset += ((strlen(Headers[i]) * FontPtr->width)+FontPtr->width);
	}
	ActivePullDown = 0;
} // MenuSystem constructor

void MenuSystem::Show()
{
	int offset = 0;
	int i=0;

	if(Visible)
		return;
	Button::Show();
	while(Headers[i][0])
	{
		GraphString(FontPtr, X1+Lines+3+offset, Y1+Lines+3,
			TextColor, Headers[i], screen);
		offset += ((strlen(Headers[i]) * FontPtr->width)
			 + FontPtr->width);
		i++;
	}
} // MenuSystem::Show

void MenuSystem::HidePullDowns()
{
	if(ActivePullDown)
	{
		HighLight(ActivePullDown);
		PullDowns[ActivePullDown-1]->Hide();
		ActivePullDown = 0;
	}
} // MenuSystem::HidePullDowns()

void MenuSystem::HandleEvent(int Event_Type, int Event,
	 int *SelectedPullDown, int *SelectedTopic)
{
	int mx,my;
	int hx1, hx2, hy1, hy2;
	int i = 0, j = 0;
	int in_header = 0, in_pulldown = 0;
	int NumTopics;
	int CurrentTopic;

	*SelectedPullDown = 0;
	*SelectedTopic = 0;
	if((Event_Type & MOUSE_EVENT)&&
		((Event & LBUTTONDOWN)||(Event & LBUTTONHELD)||(Event & LBUTTONUP)))
	{
		mouse.GetPos(&mx, &my);
		if((mx>=X1)&&(mx<=X2)&&(my>=Y1)&&(my<=Y2))  // if in the MenuBar
		{
			while(i<NumHeaders)
			{
				hx1 = StringCoords[i][0];
				hy1 = StringCoords[i][1];
				hx2 = StringCoords[i][2];
				hy2 = StringCoords[i][3];
				// if in this Header
				if((mx>=hx1)&&(mx<=hx2)&&(my>=hy1)&&(my<=hy2))
				{
					in_header = 1;
					break;
				}
				i++;
			}
			if(!in_header)
				return;
			if((ActivePullDown)&&(ActivePullDown!=(i+1)))
			{
				HighLight(ActivePullDown);
				PullDowns[ActivePullDown-1]->Hide();
			}
			if(ActivePullDown-1 != i)
				HighLight(i+1);
			ActivePullDown = i+1;
			PullDowns[i]->Show();
		}
		else
		{
			i=0;
			while(i<NumHeaders)
			{
				PullDowns[i]->GetCoords(&hx1, &hy1, &hx2, &hy2);
				// if in this PullDown
				if((mx>=hx1)&&(mx<=hx2)&&(my>=hy1)&&(my<=hy2))
				{
					if(ActivePullDown==i+1)
					{
						in_pulldown = 1;
						break;
					}
				}
				i++;
			}
			if(!in_pulldown)    // Click outside of menusystem, so cleanup
			{
				HighLight(ActivePullDown);
				PullDowns[ActivePullDown-1]->Hide();
				ActivePullDown = 0;
				return;
			}
			NumTopics = PullDowns[ActivePullDown-1]->GetNumTopics();
			while(j<NumTopics)
			{
				PullDowns[ActivePullDown-1]->
					GetStringCoords(j, &hx1, &hy1, &hx2, &hy2);
				// if in this Topic
				if((mx>=hx1)&&(mx<=hx2)&&(my>=hy1)&&(my<=hy2))
				{
					PullDowns[ActivePullDown-1]->SetSelection(j);
					break;
				}
				j++;
			}
			if(Event & LBUTTONUP)
			{
				*SelectedPullDown = ActivePullDown;
				*SelectedTopic = j+1;
				if(*SelectedTopic > NumTopics)
				{
					*SelectedPullDown = 0;
					*SelectedTopic = 0;
				}
				if(ActivePullDown)
				{
					HighLight(ActivePullDown);
					PullDowns[ActivePullDown-1]->Hide();
					ActivePullDown = 0;
				}
			}
		}
		return;
	}
	else if((Event_Type & MOUSE_EVENT) && (Event & RBUTTONUP))
	{
		if(ActivePullDown)
		{
			HighLight(ActivePullDown);
			PullDowns[ActivePullDown-1]->Hide();
			ActivePullDown = 0;
			return;
		}
	}
	else if(Event_Type & KEYBOARD_EVENT)
	{
		CurrentTopic = PullDowns[ActivePullDown-1]->GetSelection();
		switch(Event)
		{
			case SCODEAF: case SCODEAB: case SCODEAC:
			case SCODEAA: case SCODEAM:
				if(ActivePullDown)
				{
					HighLight(ActivePullDown);
					PullDowns[ActivePullDown-1]->Hide();
				}
				if(Event==SCODEAF) ActivePullDown = 1;
				if(Event==SCODEAB) ActivePullDown = 2;
				if(Event==SCODEAC) ActivePullDown = 3;
				if(Event==SCODEAA) ActivePullDown = 4;
				if(Event==SCODEAM) ActivePullDown = 5;
				HighLight(ActivePullDown);
				PullDowns[ActivePullDown-1]->Show();
				break;
			case SCODEUP:
				PullDowns[ActivePullDown-1]->SetSelection(CurrentTopic-1);
				break;
			case SCODEDOWN:
				PullDowns[ActivePullDown-1]->SetSelection(CurrentTopic+1);
				break;
			case SCODETAB:
			case SCODERIGHT:
				HighLight(ActivePullDown);
				PullDowns[ActivePullDown-1]->Hide();
				ActivePullDown++;
				if(ActivePullDown>NumHeaders)
					ActivePullDown = 1;
				HighLight(ActivePullDown);
				PullDowns[ActivePullDown-1]->Show();
				break;
			case SCODELEFT:
				HighLight(ActivePullDown);
				PullDowns[ActivePullDown-1]->Hide();
				ActivePullDown--;
				if(ActivePullDown<=0)
					ActivePullDown = NumHeaders;
				HighLight(ActivePullDown);
				PullDowns[ActivePullDown-1]->Show();
				break;
			case SCODEENTER:
				*SelectedPullDown = ActivePullDown;
				*SelectedTopic = CurrentTopic+1;
				// **** no break ****  SCODEESC must follow ! //
			case SCODEESC:
				HighLight(ActivePullDown);
				PullDowns[ActivePullDown-1]->Hide();
				ActivePullDown = 0;
				break;
		}
	} // end of if keyboard event
} // MenuSystem::HandleEvent

void MenuSystem::HighLight(int Header)
{
	Header--;
	mouse.MaybeHide();
	negatebox(StringCoords[Header][0],StringCoords[Header][1],
		StringCoords[Header][2],StringCoords[Header][3],
		screen);
	GraphString(FontPtr, StringCoords[Header][0]+1,
		StringCoords[Header][1]+1, TextColor, Headers[Header], screen);
	mouse.MaybeShow();
} // MenuSystem::HighLight

MenuSystem::~MenuSystem()
{
	int i;

	HidePullDowns();
	for(i=0;i<NumHeaders;i++)
	{
		delete PullDowns[i];
		delete StringCoords[i];
	}
	delete StringCoords;
	delete PullDowns;
	if(Visible)
		Hide();
} // MenuSystem destructor
