#ifndef _MENU_H
#define _MENU_H

#include "font.h"
#include "shapes.h"

#ifndef MAXX
#define MAXX   	319
#define MAXY	199
#endif

#ifndef BYTE
typedef unsigned char	BYTE;
typedef unsigned int	WORD;
#endif

// Declaration of PullDown class
class PullDown : public TextButton
{
	protected:
		char **Topics;
		int NumTopics;
		int **StringCoords;
		int Selection;
	public:
		PullDown(int InitX1, int InitY1, int InitColor,
			int InitTopColor, int InitBottomColor, char **InitTopics,
			BYTE *InitScreen, FontStruct *InitFontPtr, int InitTextColor,
			int InitLines = DEFAULT_LINES);
		void Show();
		void HighLight(int Topic);
		int GetSelection()
		{ return Selection; };
		int GetNumTopics()
		{ return NumTopics; };
		void SetSelection(int NewSelection);
		void GetStringCoords(int Num, int *sX1, int *sY1, int *sX2, int *sY2)
		{	*sX1 = StringCoords[Num][0]; *sY1 = StringCoords[Num][1];
			*sX2 = StringCoords[Num][2]; *sY2 = StringCoords[Num][3]; };
		~PullDown();
}; // PullDown class declaration

// Declaration of MenuSystem class
class MenuSystem : public TextButton
{
	protected:
		char **Headers;
		int NumHeaders;
		PullDown **PullDowns;
		int **StringCoords;
		int ActivePullDown;
	public:
		MenuSystem(int InitX1, int InitY1, int InitX2, int InitY2,
			int InitColor, int InitTopColor, int InitBottomColor,
			char **InitHeaders, BYTE *InitScreen, FontStruct *InitFontPtr,
			int InitTextColor, int InitLines = DEFAULT_LINES);
		void Show();
		int AnyActive()
		{ return ActivePullDown; };
		void HandleEvent(int Event_Type, int Event,
			int *SelectedPullDown, int *SelectedTopic);
		void HighLight(int Header);
		void HidePullDowns();
		~MenuSystem();
}; // MenuSystem class declaration

#endif
