/*************************************************************************

	FILE:		MOUSE.H

	AUTHOR:		Brian Tegart, C.E.T.

	DATE:		April 30, 1995

	DESCRIPTION:	Include file for Mouse class

	COPYRIGHT (c) 1995 Tegart Software

==========================================================================

	Revision:	0.0

	Date:		April 30, 1995

	By:		Brian Tegart, C.E.T.

	Action:		Creation

**************************************************************************/

#ifndef _MOUSE_H
#define _MOUSE_H

/************/
/* Includes */
/************/

/***********/
/* Defines */
/***********/
#ifndef TRUE
#define FALSE	0
#define TRUE	1
#endif

#define MNOBUTTON_DOWN		0
#define MLEFTBUTTON_DOWN	1
#define MRIGHTBUTTON_DOWN	2
#define MMIDDLEBUTTON_DOWN	4

/***************************/
/* Typedefs and structures */
/***************************/

/*********************/
/* Public prototypes */
/*********************/

// Declaration of Mouse class
class Mouse
{
	protected:
		int Visible;
		int Initialized;
	public:
		Mouse();
		void Show();
		void Hide();
		void GetRelPos(int *dx, int *dy);
		void GetPos(int *x, int *y);
		void SetPos(int x, int y);
		int ReadButtons();
		void MaybeShow();
		void MaybeHide();
		int IsInitialized()
		{ return Initialized; };
		int IsVisible()
		{ return Visible; };
}; // Mouse class declaration

#endif
