#ifndef _POPUP_H
#define _POPUP_H

#include "font.h"
#include "shapes.h"

#ifndef BYTE
typedef unsigned char	BYTE;
typedef unsigned int	WORD;
#endif

#define MAX_BUTTONS		4
#define BUT_YES			1
#define BUT_OK			2
#define BUT_NO			4
#define BUT_CANCEL		8
#define BUT_YESNO		BUT_YES | BUT_NO
#define BUT_YESNOCANCEL	BUT_YES | BUT_NO | BUT_CANCEL
#define BUT_OKCANCEL	BUT_OK | BUT_CANCEL

// Declaration of EntryBox class
class EntryBox : public TextButton
{
	protected:
		char *Entry;
		int MaxLength;
		int EntryColor;
		int DescX, DescY;		// Coordinate of description
		int EntryX, EntryY;
		int CursPos;
		void FixDisplay(WORD SCode);
		void ShowCursor();
		void HideCursor();
	public:
		EntryBox(int InitX, int InitY,
			int InitColor, int InitTopColor, int InitBottomColor,
			BYTE *InitScreen, FontStruct *InitFontPtr,
			int InitEntryX, int InitEntryY,
			int InitTextColor, int InitEntryColor,
			char *InitDescription, int InitMaxLength);
		void Show();
		void HighLight();
		void UnHighLight();
		void HideChar(int Offset);
		void HandleKey(WORD SCode);
		int GetLength()
		{ return MaxLength; };
		char *GetEntry()
		{ return Entry; };
		void SetEntry(char *NewEntry);
		~EntryBox();
}; // EntryBox class declaration

// Declaration of PopUp class
class PopUp : public TextButton
{
	protected:
		TextButton *PushButtons[MAX_BUTTONS];
		int ButtonVals[MAX_BUTTONS];
		int Buttons;
		int NumPushButtons;
		void Show();
		virtual int HandleEvent(int Event_Type, int Event);
		void Hide();
	public:
		PopUp(int InitX1, int InitY1, int InitX2, int InitY2,
			int InitColor, int InitTopColor, int InitBottomColor,
			BYTE *InitScreen, FontStruct *InitFontPtr,
			char *InitText, int InitTextColor, int InitButtons,
			int InitYOffset, int InitLines = DEFAULT_LINES);
		virtual int GetResult();
		~PopUp();
}; // PopUp class declaration

// Declaration of InfoPanel class
class InfoPanel : public PopUp
{
	protected:
		EntryBox **Entries;
		int NumEntries;
		int ActiveEntry;
		void Show();
		int HandleEvent(int Event_Type, int Event);
		void Hide();
	public:
		InfoPanel(int InitX1, int InitY1, int InitX2, int InitY2,
			int InitColor, int InitTopColor, int InitBottomColor,
			BYTE *InitScreen, FontStruct *InitFontPtr,
			char *InitText, int InitTextColor, int InitButtons,
			int InitYOffset, EntryBox **InitEntries, int InitNumEntries,
			int InitLines = DEFAULT_LINES);
		void GetEntries(char **InfoEntries);
		void SetEntry(int EntryNum, char *EntryText);
		~InfoPanel();
}; // InfoPanel class declaration

#endif
