/*************************************************************************

	FILE:		RECTANGL.CPP

	AUTHOR:		Brian Tegart, C.E.T.

	DATE:		April 30, 1995

	DESCRIPTION:	Rectangle class and functions

	COPYRIGHT (c) 1995 Tegart Software

==========================================================================

	Revision:	0.0

	Date:		April 30, 1995

	By:		Brian Tegart, C.E.T.

	Action:		Creation and modification from old file

**************************************************************************/

/************/
/* Includes */
/************/
#include "rectangl.h"

/***********/
/* Defines */
/***********/

/********************/
/* Global variables */
/********************/

/**********************/
/* External variables */
/**********************/

/******************************/
/* Static function prototypes */
/******************************/

/********************/
/* Static functions */
/********************/

/********************/
/* Public functions */
/********************/

/*------------------------------------------------------------------------

Prototype:	Rectangle::Rectangle(int InitX1, int InitY1, int InitX2,
			int InitY2, int InitColor)

Description:	Rectangle constructor

Input:		InitX1		- initial X1 coordinate
		InitY1		- initial Y1 coordinate
		InitX2		- initial X2 coordinate
		InitY2		- initial Y2 coordinate
		InitColor	- initial color

Modified:	none

Output:		none

Returns:	none

Side effects:	none

-------------------------------------------------------------------------*/
Rectangle::Rectangle(int InitX1, int InitY1, int InitX2, int InitY2,
		int InitColor)
{
	X1 = InitX1;
	Y1 = InitY1;
	X2 = InitX2;
	Y2 = InitY2;
	Color = InitColor;
	Visible = FALSE;
} // Rectangle Constructor

/*------------------------------------------------------------------------

Prototype:	Rectangle::MoveTo(int NewX1, int NewY1, int NewX2,
			int NewY2);

Description:	Move Rectangle

Input:		NewX1		- new X1 coordinate
		NewY1		- new Y1 coordinate
		NewX2		- new X2 coordinate
		NewY2		- new Y2 coordinate

Modified:	none

Output:		none

Returns:	none

Side effects:	none

-------------------------------------------------------------------------*/
void Rectangle::MoveTo(int NewX1, int NewY1, int NewX2, int NewY2)
{
	X1 = NewX1;
	Y1 = NewY1;
	X2 = NewX2;
	Y2 = NewY2;
} // Rectangle::MoveTo

