/*************************************************************************

	FILE:		RECTANGL.H

	AUTHOR:		Brian Tegart, C.E.T.

	DATE:		April 30, 1995

	DESCRIPTION:	Include file for Rectangle class

	COPYRIGHT (c) 1995 Tegart Software

==========================================================================

	Revision:	0.0

	Date:		April 30, 1995

	By:		Brian Tegart, C.E.T.

	Action:		Creation and modification from old file

**************************************************************************/

#ifndef _RECTANGL_H
#define _RECTANGL_H

/************/
/* Includes */
/************/

/***********/
/* Defines */
/***********/
#ifndef TRUE
#define TRUE	1
#define FALSE	0
#endif

#ifndef GOOD
#define GOOD	0
#define BAD	-1
#endif

/***************************/
/* Typedefs and structures */
/***************************/
#ifndef BYTE
typedef unsigned char	BYTE;
typedef unsigned int	WORD;
#endif

/*********************/
/* Public prototypes */
/*********************/

// Declaration of Rectangle class
class Rectangle
{
	protected:
		int X1, Y1, X2, Y2;
		int Color;
		int Visible;
	public:
		Rectangle(int InitX1, int InitY1, int InitX2, int InitY2,
			int InitColor);
		virtual void Show() {};
		virtual void Hide() {};
		void GetCoords(int *gX1, int *gY1, int *gX2, int *gY2)
		{ *gX1 = X1; *gY1 = Y1; *gX2 = X2; *gY2 = Y2; };
		int GetColor()
		{ return Color; };
		void SetColor(int NewColor)
		{ Color = NewColor; };
		virtual void MoveTo(int NewX1, int NewY1,
			int NewX2, int NewY2);
}; // Rectangle class declaration

#endif
