#ifndef _SCANCODE_H
#define _SCANCODE_H

/* The following are values returned from Interrupt 16H, Function 1
        The first byte of each value is the scan code, and
        the last byte of each value is the ASCII code */ 

#define SCODEa               0x1E61
#define SCODEb               0x3062
#define SCODEc               0x2E63
#define SCODEd               0x2064
#define SCODEe               0x1265
#define SCODEf               0x2166
#define SCODEg               0x2267
#define SCODEh               0x2368
#define SCODEi               0x1769
#define SCODEj               0x246A
#define SCODEk               0x256B
#define SCODEl               0x266C
#define SCODEm               0x326D
#define SCODEn               0x316E
#define SCODEo               0x186F
#define SCODEp               0x1970
#define SCODEq               0x1071
#define SCODEr               0x1372
#define SCODEs               0x1F73
#define SCODEt               0x1474
#define SCODEu               0x1675
#define SCODEv               0x2F76
#define SCODEw               0x1177
#define SCODEx               0x2D78
#define SCODEy               0x1579
#define SCODEz               0x2C7A

#define SCODEA               0x1E41
#define SCODEB               0x3042
#define SCODEC               0x2E43
#define SCODED               0x2044
#define SCODEE               0x1245
#define SCODEF               0x2146
#define SCODEG               0x2247
#define SCODEH               0x2348
#define SCODEI               0x1749
#define SCODEJ               0x244A
#define SCODEK               0x254B
#define SCODEL               0x264C
#define SCODEM               0x324D
#define SCODEN               0x314E
#define SCODEO               0x184F
#define SCODEP               0x1950
#define SCODEQ               0x1051
#define SCODER               0x1352
#define SCODES               0x1F53
#define SCODET               0x1454
#define SCODEU               0x1655
#define SCODEV               0x2F56
#define SCODEW               0x1157
#define SCODEX               0x2D58
#define SCODEY               0x1559
#define SCODEZ               0x2C5A

#define SCODESPACE           0x3920
#define SCODEENTER           0x1C0D
#define SCODECOMMA           0x332C
#define SCODEPERIOD          0x342E
#define SCODEFSLASH          0x352F
#define SCODESEMICOLON       0x273B
#define SCODESQUOTE          0x2827
#define SCODELSQUARE         0x1A5B
#define SCODERSQUARE         0x1B5D
#define SCODEMINUS           0x0C2D
#define SCODEEQUALS          0x0D3D
#define SCODEBSLASH          0x2B5C
#define SCODELESS            0x333C
#define SCODEGREATER         0x343E
#define SCODEQUESTION        0x353F
#define SCODECOLON           0x273A
#define SCODEDQUOTES         0x2822
#define SCODELSQUIG          0x1A7B
#define SCODERSQUIG          0x1B7D
#define SCODEUNDER           0x0C5F
#define SCODEPLUS            0x0D2B
#define SCODEPIPE            0x2B7C

#define SCODEESC             0x011B
#define SCODEBACKSPACE       0x0E08
#define SCODETICK            0x2960
#define SCODETAB             0x0F09
#define SCODESTAB            0x0F00
#define SCODETILDE           0x297E
#define SCODE1               0x0231
#define SCODE2               0x0332
#define SCODE3               0x0433
#define SCODE4               0x0534
#define SCODE5               0x0635
#define SCODE6               0x0736
#define SCODE7               0x0837
#define SCODE8               0x0938
#define SCODE9               0x0A39
#define SCODE0               0x0B30
#define SCODEEXCLAMATION     0x0221
#define SCODEATSIGN          0x0340
#define SCODEPOUND           0x0423
#define SCODEDOLLAR          0x0524
#define SCODEPERCENT         0x0625
#define SCODECARAT           0x075E
#define SCODEAMPERSAND       0x0826
#define SCODESTAR            0x092A
#define SCODELBRACKET        0x0A28
#define SCODERBRACKET        0x0B29

#define SCODEA1              0x7800
#define SCODEA2              0x7900
#define SCODEA3              0x7A00
#define SCODEA4              0x7B00
#define SCODEA5              0x7C00
#define SCODEA6              0x7D00
#define SCODEA7              0x7E00
#define SCODEA8              0x7F00
#define SCODEA9              0x8000
#define SCODEA0              0x8100
#define SCODEAMINUS          0x8200
#define SCODEAEQUALS         0x8300

#define SCODEC2              0x0300
#define SCODEC6              0x071E
#define SCODECMINUS          0x0C1F
#define SCODECBSLASH         0x2B1C
#define SCODECBACKSPACE      0x0E7F
#define SCODECENTER          0x1C0A
#define SCODECHOME           0x7700
#define SCODECPGUP           0x8400
#define SCODECEND            0x7500
#define SCODECPGDN           0x7600
#define SCODECLEFT           0x7300
#define SCODECRIGHT          0x7400
#define SCODECPRSC           0x7200

#define SCODEKC1             0x7500
#define SCODEKC3             0x7600
#define SCODEKC4             0x7300
#define SCODEKC6             0x7400
#define SCODEKC7             0x7700
#define SCODEKC9             0x8400
#define SCODEKS1             0x4F31
#define SCODEKS2             0x5032
#define SCODEKS3             0x5133
#define SCODEKS4             0x4B34
#define SCODEKS5             0x4C35
#define SCODEKS6             0x4D36
#define SCODEKS7             0x4737
#define SCODEKS8             0x4838
#define SCODEKS9             0x4939
#define SCODEKS0             0x5230
#define SCODEKSPERIOD        0x532E

#define SCODELEFT            0x4B00
#define SCODERIGHT           0x4D00
#define SCODEUP              0x4800
#define SCODEDOWN            0x5000
#define SCODEDELETE          0x5300
#define SCODEEND             0x4F00
#define SCODEPGDN            0x5100
#define SCODEINSERT          0x5200
#define SCODEHOME            0x4700
#define SCODEPGUP            0x4900

#define SCODEF1              0x3B00
#define SCODEF2              0x3C00
#define SCODEF3              0x3D00
#define SCODEF4              0x3E00
#define SCODEF5              0x3F00
#define SCODEF6              0x4000
#define SCODEF7              0x4100
#define SCODEF8              0x4200
#define SCODEF9              0x4300
#define SCODEF10             0x4400
#define SCODESF1             0x5400
#define SCODESF2             0x5500
#define SCODESF3             0x5600
#define SCODESF4             0x5700
#define SCODESF5             0x5800
#define SCODESF6             0x5900
#define SCODESF7             0x5A00
#define SCODESF8             0x5B00
#define SCODESF9             0x5C00
#define SCODESF10            0x5D00
#define SCODECF1             0x5E00
#define SCODECF2             0x5F00
#define SCODECF3             0x6000
#define SCODECF4             0x6100
#define SCODECF5             0x6200
#define SCODECF6             0x6300
#define SCODECF7             0x6400
#define SCODECF8             0x6500
#define SCODECF9             0x6600
#define SCODECF10            0x6700
#define SCODEAF1             0x6800
#define SCODEAF2             0x6900
#define SCODEAF3             0x6A00
#define SCODEAF4             0x6B00
#define SCODEAF5             0x6C00
#define SCODEAF6             0x6D00
#define SCODEAF7             0x6E00
#define SCODEAF8             0x6F00
#define SCODEAF9             0x7000
#define SCODEAF10            0x7100
                                    
#define SCODEAA              0x1E00
#define SCODEAB              0x3000
#define SCODEAC              0x2E00
#define SCODEAD              0x2000
#define SCODEAE              0x1200
#define SCODEAF              0x2100
#define SCODEAG              0x2200
#define SCODEAH              0x2300
#define SCODEAI              0x1700
#define SCODEAJ              0x2400
#define SCODEAK              0x2500
#define SCODEAL              0x2600
#define SCODEAM              0x3200
#define SCODEAN              0x3100
#define SCODEAO              0x1800
#define SCODEAP              0x1900
#define SCODEAQ              0x1000
#define SCODEAR              0x1300
#define SCODEAS              0x1F00
#define SCODEAT              0x1400
#define SCODEAU              0x1600
#define SCODEAV              0x2F00
#define SCODEAW              0x1100
#define SCODEAX              0x2D00
#define SCODEAY              0x1500
#define SCODEAZ              0x2C00
#define SCODECA              0x1E01
#define SCODECB              0x3002
#define SCODECC              0x2E03
#define SCODECD              0x2004
#define SCODECE              0x1205
#define SCODECF              0x2106
#define SCODECG              0x2207
#define SCODECH              0x2308
#define SCODECI              0x1709
#define SCODECJ              0x240A
#define SCODECK              0x250B
#define SCODECL              0x260C
#define SCODECM              0x320D
#define SCODECN              0x310E
#define SCODECO              0x180F
#define SCODECP              0x1910
#define SCODECQ              0x1011
#define SCODECR              0x1312
#define SCODECS              0x1F13
#define SCODECT              0x1414
#define SCODECU              0x1615
#define SCODECV              0x2F16
#define SCODECW              0x1117
#define SCODECX              0x2D18
#define SCODECY              0x1519
#define SCODECZ              0x191A
                
#define SCODEKFSLASH         0x352F
#define SCODEKSTAR           0x372A
#define SCODEKMINUS          0x4A2D
#define SCODEKPLUS           0x4E2B
#define SCODEKENTER          0x1C0D
#define SCODEK1              0x4F00
#define SCODEK2              0x5000
#define SCODEK3              0x5100
#define SCODEK4              0x4B00
#define SCODEK6              0x4D00
#define SCODEK7              0x4700
#define SCODEK8              0x4800
#define SCODEK9              0x4900
#define SCODEK0              0x5200
#define SCODEKPERIOD         0x5300

#endif
