#ifndef _SCREEN_H
#define _SCREEN_H

#ifndef BYTE
typedef unsigned char	BYTE;
typedef unsigned int	WORD;
#endif

#define RGB_RED		0
#define RGB_GREEN	1
#define RGB_BLUE	2

#define BLACK		0
#define BLUE		1
#define GREEN		2
#define CYAN		3
#define RED			4
#define MAGENTA		5
#define BROWN		6
#define L_GRAY		7
#define GRAY		8
#define	L_BLUE		9
#define L_GREEN		10
#define L_CYAN		11
#define L_RED		12
#define L_MAGENTA	13
#define YELLOW		14
#define WHITE		15

// Functions is SCREEN.ASM
extern "C" {
	void cls(BYTE *screen_adr);
	void fillscreen(BYTE *screen_adr, int color);
	void setgmode(int mode);
	void setpalette(BYTE *color_regs, int firstreg, int numregs);
	void getpalette(BYTE *buffer);
	void setcolor(int colornum, BYTE red, BYTE green, BYTE blue);
	void getbox(BYTE *dest, int x1, int y1, int numcols,
		int numrows, BYTE *screen);
	void putbox(BYTE *buff, int x1, int y1, int numcols,
		int numrows, BYTE *screen);
	void putboxtransparent(BYTE *buff, int x1, int y1, int numcols,
		int numrows, BYTE *screen);
	void transferbox(int destx1, int desty1, BYTE *destscreen,
		int srcx1, int srcy1, BYTE *srcscreen, int numcols, int numrows);
	void copyscreen(BYTE *destscreen, BYTE *srcscreen);
	void WaitForRetrace();
}

#endif
