#ifndef _SPRITE_H
#define _SPRITE_H
#include "screen.h"

#ifndef min
#define min(a, b) ((a) < (b) ? (a) : (b))
#define max(a, b) ((a) > (b) ? (a) : (b))
#endif

#define ABS(a) ((a) < 0 ? 0-(a) : (a))

#ifndef BYTE
typedef unsigned char	BYTE;
typedef unsigned int	WORD;
#endif

// Declaration of sprite class
class Sprite
{
	protected:
		int NumSprites;
		BYTE **images;			// Pointer to array of sprite bitmaps
		int width, height;		// Width and height of sprite
		int xsprite, ysprite;	// Current x,y coordinates of sprite
		int xbg, ybg;			// coordinates for background
		BYTE *savebuffer;		// Pointer for saving background
		BYTE *screen;			// pointer to video screen
		BYTE *shadow;			// pointer to video screen shadow
	public:
		Sprite(int num_sprites, int w, int h, BYTE *InitScreen,
			BYTE *InitShadow);
		void grab(BYTE *buffer, int sprite_num, int x1, int y1)
		{ getbox(images[sprite_num], x1, y1, width, height, buffer); };
		void SetNewCoords(int NewX, int NewY)
		{ xsprite = NewX, ysprite = NewY; xbg = NewX; ybg = NewY; };
		void put(int sprite_num, int x, int y, BYTE *screen);
		void puttransparent(int sprite_num, int x, int y, BYTE *screen);
		void erase(BYTE *screen)
		{ putbox(savebuffer, xsprite, ysprite, width, height, screen); };
		void Move(int dx, int dy, int image_num);
		void SetNewShadow(BYTE *NewShadow)
		{ shadow = NewShadow; };
		BYTE *GetSpriteImage(int imagenum)
		{ return images[imagenum]; };
		int GetNumSprites()
		{ return NumSprites; };
		void GetDimensions(int *W, int *H)
		{ *W = width; *H = height; };
		void Copy(int destnum, int sourcenum);
		~Sprite();
}; /* Sprite class declaration */

#endif

