#include <conio.h>
#include <dos.h>
#include <stdio.h>
#include "animfunc.h"
#include "evntmngr.h"
#include "font.h"
#include "line.h"
#include "pcx.h"
#include "popup.h"
#include "rtrncode.h"
#include "sprite.h"
#include "title.h"
#include "wait.h"

int ChecksumTitle()
{
	FILE *fp;
	unsigned char checksum = 0;
	unsigned char bytein;

	fp = fopen(TITLE_FILENAME, "r");
	if(fp == NULL)
		return NO_FILE_OPEN;

	while(!feof(fp))
	{
		fread(&bytein,1,1,fp);
		checksum ^= bytein;
	}

	fclose(fp);

	if(checksum == TITLE_CHECKSUM)
		return GOOD;
	return BAD;
}

int AnimTitleScreen(BYTE *screen, BYTE *shadow, FontStruct *Font,
	int errortextcolor)
{
	Pcx *TitlePcx = new Pcx(screen);
	Sprite *TitleSprite = new Sprite(NUM_TITLE_SPRITES,
		TITLE_WIDTH, TITLE_HEIGHT, screen, shadow);
	int done = 0;
	int rc;
	int sx,sy;
	int i,x,y;
	unsigned long int wait_time = WAIT_SMALLEST;
	int event_type, event;

	rc = ChecksumTitle();
	if(rc!=GOOD)
	{
		switch(rc)
		{
			case NO_FILE_OPEN:
				PopMessage("Cannot open ANIM256.DAT", BUT_OK, screen, Font,
					errortextcolor);
				delete TitlePcx;
				delete TitleSprite;
				return rc;
			case BAD:
				PopMessage("ANIM256.DAT is corrupt", BUT_OK, screen, Font,
					errortextcolor);
				delete TitlePcx;
				delete TitleSprite;
				return GOOD;
		}
	}

	rc = TitlePcx->load(TITLE_FILENAME);
	if(rc==NO_MEM)
	{
		PopMessage("Not enough memory", BUT_OK, screen, Font,
				errortextcolor);
		delete TitlePcx;
		delete TitleSprite;
		return rc;
	}

	setpalette(TitlePcx->GetPalette(), 0, 256);

	cls(screen);
	copyscreen(shadow, screen);

	Sprite *_256Sprite = new Sprite(NUM_256_SPRITES,
		_256_WIDTH, _256_HEIGHT, screen, shadow);
	Sprite *AnimSprite = new Sprite(NUM_ANIM_SPRITES,
		ANIM_WIDTH, ANIM_HEIGHT, screen, shadow);
	for(i=0,sx=252,sy=0;i<NUM_256_SPRITES;i++)
	{
		_256Sprite->grab(TitlePcx->GetImage(), i, sx, sy);
		sx+=_256_WIDTH;
		if(sx+_256_WIDTH>=320)
		{
			sx = 0;
			sy += _256_HEIGHT;
		}
	}
	for(i=0,sx=264,sy=48;i<NUM_ANIM_SPRITES;i++)
	{
		AnimSprite->grab(TitlePcx->GetImage(), i, sx, sy);
		sx+=ANIM_WIDTH;
		if(sx+ANIM_WIDTH>=320)
		{
			sx = 0;
			sy += ANIM_HEIGHT;
		}
	}
	for(i=0,sx=0;i<NUM_TITLE_SPRITES;i++,sx+=TITLE_WIDTH)
		TitleSprite->grab(TitlePcx->GetImage(), i, sx, 0);

	for(i=0,x=0,y=0;i<36;i++,x++,y++)
	{
		hlinedraw(x, y, MAXX-x, 64+i, shadow);
		hlinedraw(x, MAXY-y, MAXX-x, 64+i, shadow);
	}
	for(i=0,x=0,y=0;i<36;i++,x++,y++)
	{
		vlinedraw(x, y, MAXY-y, 64+i, shadow);
		vlinedraw(MAXX-x, y, MAXY-y, 64+i, shadow);
	}

	_256Sprite->puttransparent(0, 4, 20, shadow);
	_256Sprite->puttransparent(1, 42, 20, shadow);
	_256Sprite->puttransparent(2, 80, 20, shadow);
	_256Sprite->puttransparent(3, 156, 20, shadow);
	_256Sprite->puttransparent(4, 194, 20, shadow);
	_256Sprite->puttransparent(5, 232, 20, shadow);
	_256Sprite->puttransparent(6, 239, 20, shadow);
	_256Sprite->puttransparent(7, 277, 20, shadow);
	AnimSprite->puttransparent(0, 93, 60, shadow);
	AnimSprite->puttransparent(1, 119, 68, shadow);
	AnimSprite->puttransparent(2, 145, 60, shadow);
	AnimSprite->puttransparent(3, 171, 60, shadow);
	AnimSprite->puttransparent(4, 176, 60, shadow);
	AnimSprite->puttransparent(5, 198, 60, shadow);
	AnimSprite->puttransparent(6, 63, 90, shadow);
	AnimSprite->puttransparent(7, 89, 90, shadow);
	AnimSprite->puttransparent(8, 115, 90, shadow);
	AnimSprite->puttransparent(9, 120, 90, shadow);
	AnimSprite->puttransparent(10, 146, 90, shadow);
	AnimSprite->puttransparent(11, 172, 90, shadow);
	AnimSprite->puttransparent(12, 217, 90, shadow);

	delete AnimSprite;
	delete _256Sprite;

	GraphString(Font, 80, 118, 100, "**FREEWARE** Version", shadow);
	GraphString(Font, 85, 140, 14, "Wait...", shadow);
	GraphString(Font, 52, 175, 9, "Programmed By: Brian Tegart", shadow);

	copyscreen(screen, shadow);

	Sprite *TimerSprite = new Sprite(NUM_TIMER_SPRITES,
		TIMER_WIDTH, TIMER_HEIGHT, screen, shadow);
	for(i=0,sx=264,sy=72;i<NUM_TIMER_SPRITES;i++)
	{
		TimerSprite->grab(TitlePcx->GetImage(), i, sx, sy);
		sx+=TIMER_WIDTH;
		if(sx+TIMER_WIDTH>=320)
		{
			sx = 0;
			sy += TIMER_HEIGHT;
		}
	}
	delete TitlePcx;

	int dir = 1;
	int sp = 0;
	i=0;
	TitleSprite->puttransparent(0, 0, 95, shadow);
	TimerSprite->puttransparent(0, 148, 132, screen);
	int timer = 4;
	int counter = 50;
	do
	{
		if(i<95)
		{
			TitleSprite->Move(2, 0, sp);
		}
		else
		{
			i=95;
			TitleSprite->Move(0, 0, sp);
		}
		sp += dir;
		if(sp==9)
			dir = -1;
		if(sp==0)
			dir = 1;
		i++;
		Wait(wait_time);
		if((counter >= 30) && (timer < 10))
		{
			counter = 0;
			TimerSprite->Move(0, 0, timer);
			timer++;
		}
		getevent(MOUSE_EVENTS + KEYBOARD_EVENTS, &event_type, &event);
		if(event != NOEVENT)
		{
			if(event_type & KEYBOARD_EVENT)
				done = 1;
			if(event_type & MOUSE_EVENT)
				if((event & LBUTTONDOWN) || (event & RBUTTONDOWN))
					done = 1;
		}
		if(timer == 10)
		{
			GraphString(Font, 183, 140, 200, "Press a key", screen);
			getevent(MOUSE_EVENTS + KEYBOARD_EVENTS, &event_type, &event);
			if(event != NOEVENT)
			{
				if(event_type & KEYBOARD_EVENT)
					done = 1;
				if(event_type & MOUSE_EVENT)
					if((event & LBUTTONDOWN) || (event & RBUTTONDOWN))
						done = 1;
			}
		}
		counter ++;
		WaitForRetrace();
		RotatePalette(36,251,1);
	} while(!done);

	delete TitleSprite;
	delete TimerSprite;

	FadeToBlack(screen, WAIT_100th * 3);

	return GOOD;
}
