;*************************************************************************
;
;	FILE:		WAIT.ASM
;
;	AUTHOR:		Brian Tegart, C.E.T.
;
;	DATE:		April 30, 1995
;
;	DESCRIPTION:	DOS Wait routines
;
;	COPYRIGHT (c) 1995 Tegart Software
;
;=========================================================================
;
;	Revision:	0.0
;
;	Date:		April 30, 1995
;
;	By:		Brian Tegart, C.E.T.
;
;	Action:		Creation and modification from old file
;
;*************************************************************************

;**************
;* Directives *
;**************
.286
.MODEL        large
.CODE

;************
;* Includes *
;************

;*************************
;* Function declarations *
;*************************
PUBLIC        _Wait

;***********
;* Equates *
;***********

;**************
;* Structures *
;**************

;***************
;* Global data *
;***************

;*****************
;* External data *
;*****************

;********************
;* Public functions *
;********************

;------------------------------------------------------------------------
;
;Prototype:	void Wait(unsigned long MicroSeconds);
;
;Description:   Wait (suspend) for the specified number of microseconds
;
;Input:		MicroSeconds	- the time to suspend
;
;Modified:	none
;
;Output:	none
;
;Returns:	none
;
;Side effects:	none
;
;NOTES:		MicroSeconds must be a multiple of 976
;
;------------------------------------------------------------------------
_Wait   PROC
	ARG	WaitLow:WORD,WaitHigh:WORD
	push	bp
	mov	bp,sp
	push	ax
	push	cx
	push	dx
	mov	ah,86h			; Function number
	mov	cx,WaitHigh
	mov	dx,WaitLow
	int	15h
	pop	dx
	pop	cx
	pop	ax
	mov	sp,bp
	pop	bp
	ret
_Wait   ENDP

	END

